<link rel="import" href="../bower_components/polymer/polymer-element.html">
<link rel="import" href="../bower_components/polymer/lib/elements/dom-if.html">
<link rel="import" href="../bower_components/app-layout/app-drawer/app-drawer.html">
<link rel="import" href="../bower_components/app-layout/app-drawer-layout/app-drawer-layout.html">
<link rel="import" href="../bower_components/app-layout/app-header/app-header.html">
<link rel="import" href="../bower_components/app-layout/app-header-layout/app-header-layout.html">
<link rel="import" href="../bower_components/app-layout/app-scroll-effects/app-scroll-effects.html">
<link rel="import" href="../bower_components/app-layout/app-toolbar/app-toolbar.html">
<link rel="import" href="../bower_components/app-route/app-location.html">
<link rel="import" href="../bower_components/app-route/app-route.html">
<link rel="import" href="../bower_components/iron-pages/iron-pages.html">
<link rel="import" href="../bower_components/iron-selector/iron-selector.html">
<link rel="import" href="../bower_components/iron-icon/iron-icon.html">
<link rel="import" href="../bower_components/vaadin-lumo-styles/icons.html">
<link rel="import" href="../bower_components/vaadin-button/vaadin-button.html">
<link rel="import" href="../bower_components/brum-global-variable/brum-global-variable.html">
<link rel="import" href="../bower_components/app-localstorage-tidy-string/app-localstorage-tidy-string.html">
<link rel="import" href="shared-styles.html">

<link rel="lazy-import" href="submissions.html">
<link rel="lazy-import" href="submit.html">
<link rel="lazy-import" href="matches.html">
<link rel="lazy-import" href="deployments.html">
<link rel="lazy-import" href="settings.html">
<link rel="lazy-import" href="404.html">

<dom-module id="probot-frontend-app">
  <template>
    <style include="shared-styles">
      :host {
        display: block;
      }
      app-drawer-layout:not([narrow]) [drawer-toggle] {
        display: none;
      }
      app-header {
        color: var(--lumo-base-color);
        background-color: var(--lumo-primary-color);
      }
      app-header vaadin-button {
        color: var(--lumo-base-color);
      }
      .drawer-list {
        margin: var(--lumo-space-tall-m);
      }
      .drawer-list a {
        display: block;
        padding: 0 var(--lumo-space-m);
        color: var(--lumo-secondary-text-color);
        line-height: var(--lumo-size-m);
        text-decoration: none;
      }
      /*noinspection CssUnusedSymbol*/
      .drawer-list a.iron-selected {
        color: var(--lumo-body-text-color);
        font-weight: bold;
      }
    </style>

    <!-- settings -->
    <brum-global-variable key="backendBase" value="{{backendBase}}"></brum-global-variable>
    <app-localstorage-tidy-string key="backendBase" data="{{backendBase}}"
                                  default-value="http://ledomi.duckdns.org:3000"></app-localstorage-tidy-string>
    <iron-ajax auto with-credentials url="[[backendBase]]/api/ping" loading="{{pingLoading}}"
               last-error="{{pingError}}" last-response="{{pingResponse}}"></iron-ajax>
    <template is="dom-if" if="[[pingResponse]]">
      <iron-ajax auto with-credentials url="[[backendBase]]/api/userAuth/ping/user" loading="{{userPingLoading}}"
                 last-error="{{userPingError}}" last-response="{{userPingResponse}}"></iron-ajax>
      <iron-ajax auto with-credentials url="[[backendBase]]/api/teamAuth/ping/team" loading="{{teamPingLoading}}"
                 last-error="{{teamPingError}}" last-response="{{teamPingResponse}}"></iron-ajax>
      <brum-global-variable key="userAuth" value="[[_toBool(userPingResponse)]]"></brum-global-variable>
      <brum-global-variable key="teamAuth" value="[[_toBool(teamPingResponse)]]"></brum-global-variable>
      <template is="dom-if" if="[[!userPingLoading]]">
        <template is="dom-if" if="[[!teamPingLoading]]">
          <brum-global-variable key="apiBase"
                                value="[[_calcApiBase(backendBase, userPingResponse, teamPingResponse)]]"></brum-global-variable>
        </template>
      </template>
    </template>

    <app-location
        route="{{route}}"
        url-space-regex="^[[rootPath]]">
    </app-location>

    <app-route
        route="{{route}}"
        pattern="[[rootPath]]:page"
        data="{{routeData}}"
        tail="{{subroute}}">
    </app-route>

    <brum-global-variable key="userAuth" value="{{userAuth}}" readonly></brum-global-variable>
    <brum-global-variable key="teamAuth" value="{{teamAuth}}" readonly></brum-global-variable>
    <app-drawer-layout fullbleed narrow="{{narrow}}">
      <!-- Drawer content -->
      <app-drawer id="drawer" slot="drawer" swipe-open="[[narrow]]">
        <app-toolbar>Menu</app-toolbar>
        <iron-selector selected="[[page]]" attr-for-selected="name" class="drawer-list" role="navigation">
          <template is="dom-if" if="[[userAuth]]">
            <a name="submissions" href="submissions">Code submissions</a>
            <a name="submit" href="submit">Submit new</a>
          </template>
          <a name="matches" href="matches">Matches</a>
          <a name="deployments" href="deployments">Deployments</a>
          <a name="settings" href="settings">Settings</a>
        </iron-selector>
        <template is="dom-if" if="[[_nand(userAuth, teamAuth)]]">
          <div class="card">
            <b>Note:</b><br>
            Sign in at the <a href="settings">settings</a>
          </div>
        </template>
      </app-drawer>

      <!-- Main content -->
      <app-header-layout has-scrolling-region>

        <app-header slot="header" condenses reveals effects="waterfall">
          <app-toolbar>
            <vaadin-button theme="icon" aria-label="Toggle menu" drawer-toggle>
              <iron-icon icon="lumo:menu"></iron-icon>
            </vaadin-button>
            <div main-title>probot</div>
          </app-toolbar>
        </app-header>

        <iron-pages
            selected="[[page]]"
            attr-for-selected="name"
            fallback-selection="404"
            role="main">
          <submissions-list name="submissions"></submissions-list>
          <submit-new name="submit"></submit-new>
          <matches-list name="matches"></matches-list>
          <deployments-list name="deployments"></deployments-list>
          <settings-page name="settings"></settings-page>
          <app-404 name="404"></app-404>
        </iron-pages>
      </app-header-layout>
    </app-drawer-layout>
  </template>

  <script>
    // Gesture events like tap and track generated from touch will not be
    // preventable, allowing for better scrolling performance.
    Polymer.setPassiveTouchGestures(true);

    class ProbotFrontendApp extends Polymer.Element {
      static get is() {
        return 'probot-frontend-app';
      }

      // noinspection JSUnusedGlobalSymbols
      static get properties() {
        return {
          page: {
            type: String,
            reflectToAttribute: true,
            observer: '_pageChanged',
          },
          routeData: Object,
          subroute: String,
          // This shouldn't be necessary, but the Analyzer isn't picking up
          // Polymer.Element#rootPath
          rootPath: String,
        };
      }

      // noinspection JSUnusedGlobalSymbols
      static get observers() {
        return [
          '_routePageChanged(routeData.page)',
        ];
      }

      // noinspection JSUnusedGlobalSymbols
      _routePageChanged(page) {
        // If no page was found in the route data, page will be an empty string.
        // Default to the value given below in that case.
        // noinspection JSUnusedGlobalSymbols
        this.page = page || 'matches';
        // Close a non-persistent drawer when the page & route are changed.
        if (!this.$.drawer.persistent) {
          this.$.drawer.close();
        }
      }

      _pageChanged(page) {
        // Load page import on demand. Show 404 page if fails
        const resolvedPageUrl = this.resolveUrl(page + '.html');
        Polymer.importHref(
          resolvedPageUrl,
          null,
          this._showPage404.bind(this),
          true
        );
      }

      _showPage404() {
        // noinspection JSUnusedGlobalSymbols
        this.page = '404';
      }

      // noinspection JSUnusedGlobalSymbols
      _drawerToggle() {
        this.$.drawer.toggle();
      }

      // noinspection JSMethodCanBeStatic
      // noinspection JSUnusedGlobalSymbols
      _toBool(val) {
        return !!val;
      }

      // noinspection JSMethodCanBeStatic
      // noinspection JSUnusedGlobalSymbols
      _calcApiBase(backendBase, userPingResult, teamPingResult) {
        const userAuth = userPingResult && userPingResult.type === 'pong';
        const teamAuth = teamPingResult && teamPingResult.type === 'pong';

        return backendBase + '/api' +
          (userAuth ? '/userAuth' : '') +
          (teamAuth ? '/teamAuth' : '');
      }

      // noinspection JSMethodCanBeStatic
      // noinspection JSUnusedGlobalSymbols
      _nand(...values) {
        return !values.reduce((a, v) => a && v, true);
      }
    }

    window.customElements.define(ProbotFrontendApp.is, ProbotFrontendApp);
  </script>
</dom-module>
